#include <stdio.h>
#include <stdlib.h>
#include <time.h> 
#include <limits.h>

#define TAB_SIZE 10

void randtab(int tab[], int n, int lim) {
    int i;
    for (i=0; i<n; i++) 
	tab[i] = (int) (((double) lim+1) * rand() / (RAND_MAX+1.0));
}

void printtab(int tab[], int n) {
    int i;
    for (i=0; i<n; i++) 
	printf("tab[%d] = %d\n",i,tab[i]);
}

void swap(int tab[], int i, int j) {
    int tmp = tab[i];
    tab[i] = tab[j]; 
    tab[j] = tmp;
}

int partition(int tab[], int inf, int sup) {
    int idx_pivot = (inf + sup)/2; // choix d'un pivot (ici, le milieu)
    int i, j = inf; // j : index du pivot final
    swap(tab,inf,idx_pivot); // // On met le pivot en premire position
    for (i = inf + 1; i <= sup; i++)
	if (tab[i] < tab[inf]) swap(tab,++j,i); // + petit lments  gauche
    swap(tab,inf,j); // on remet le pivot au bon endroit dans le tableau
    return j;
}

void quicksort_rec(int tab[], int idx_g, int idx_d) {
    if (idx_g < idx_d) { // inutile de trier les tableau d'un lment
	int idx_pivot = partition(tab, idx_g, idx_d); 
	quicksort_rec(tab, idx_g, idx_pivot-1);
	quicksort_rec(tab, idx_pivot + 1, idx_d);
    }
}

int compar(const void * a, const void * b) { // pour qsort
    int c = * (int *) a;
    int d = * (int *) b;
    return (c < d) ? -1 : (c > d) ? 1 : 0;
}

void quicksort(int tab[], int n) {
    quicksort_rec(tab, 0, n-1);
}

int main() 
{
    int tab[TAB_SIZE]; 
    srand(time(NULL)); // Initialisation du gnrateur de nombres pseudo-alatoire
    randtab(tab, TAB_SIZE, 10);
    printtab(tab, TAB_SIZE);
    quicksort(tab, TAB_SIZE);
    //qsort(tab, TAB_SIZE, sizeof(int), compar);
    printf("----\n");
    printtab(tab, TAB_SIZE);
    return 0;
}



