#include <stdio.h>
#include <stdlib.h>
#include <time.h>

void print_tab(int tab[], size_t n) {
    size_t i;
    if (n <= 0) return;
    for (i=0; i<n; i++) printf("+----");
    printf("+\n");
    for (i=0; i<n; i++) printf("| %2d ", tab[i]);
    printf("|\n");
    for (i=0; i<n; i++) printf("+----");
    printf("+\n");
}

void randtab(int tab[], int n, int lim); // Cf. exercice /*@\ref{chap:types}.\ref{func:quicksort}@*/.

int main()
{
    size_t n1=0, n2=0, i;
    printf("Entrer la taille du premier tableau: n1 = "); scanf("%lu",&n1);
    printf("Entrer la taille du second  tableau: n2 = "); scanf("%lu",&n2);
    int *tab1, *tab2;
    tab1 = (int *) malloc(n1 * sizeof(int)); 
    tab2 = (int *) malloc(n2 * sizeof(int)); 
    if ((tab1 == NULL) || (tab2 == NULL)) {
	fprintf(stderr, "Erreur lors de l'allocation des tableaux\n");
	return 1;
    }
    srand(time(NULL));
    randtab(tab1,n1,99);
    randtab(tab2,n2,99);
    printf("Affichage du tableau tab1 de taille n1 = %lu:\n",n1);
    print_tab(tab1,n1);
    printf("Affichage du tableau tab2 de taille n2 = %lu:\n",n2);
    print_tab(tab2,n2);
    if ( (tab1 = (int *) realloc((void *) tab1, n1 + n2)) == NULL) {
	fprintf(stderr, "Erreur lors de la rallocation du premier tableau\n");
	return 1;
    }    
    for (i=n1; i<n1+n2; i++) tab1[i] = tab2[i-n1];// On aurait pu utiliser memcpy.
    printf("Affichage du tableau tab1 de taille n1+n2 = %lu:\n",n1+n2);
    print_tab(tab1,n1+n2);
    free(tab1); 
    free(tab2);
    return 0;
}


    /* Remplit tab avec des valeurs alatoires comprises entre 0 et lim. */
void randtab(int tab[], int n, int lim) {
    int i;
    for (i=0; i<n; i++) 
	tab[i] = (int) (((double) lim+1) * rand() / (RAND_MAX+1.0));
}
