#include <stdio.h>

#define L 6            // nombre de lignes
#define C 5            // nombre de colonnes
#define BLACK_CHAR '*' // caractre "pixel noir"
#define WHITE_CHAR ' ' // caractre "pixel blanc"

typedef enum { WHITE, BLACK } pixel;

void miroirVertical(pixel picture[L][C], pixel res[L][C]) {
    size_t i,j;
    for (i=0; i<L; i++){
	    for (j=0; j<C; j++) 
	        res[i][C-1-j] = picture[i][j];
    }
}
void miroirHorizontal(pixel picture[L][C], pixel res[L][C]) {
    size_t i,j;
    for (i=0; i<L; i++){
    	for (j=0; j<C; j++) 
	        res[L-1-i][j] = picture[i][j];
    }
}
void rotationDroite(pixel picture[L][C], pixel res[C][L]) {
    size_t i,j;
    for (i=0; i<L; i++){
	    for (j=0; j<C; j++) 
	        res[j][C-i] = picture[i][j];
    }
}
void rotationGauche(pixel picture[L][C], pixel res[C][L]) {
    size_t i,j;
    for (i=0; i<L; i++){
	    for (j=0; j<C; j++) 
	        res[C-1-j][i] = picture[i][j];
    }
}
size_t compare(pixel picture1[L][C], pixel picture2[L][C]) {
    size_t res=0,i,j;
    for (i=0; i<L; i++){
	    for (j=0; j<C; j++) 
	        if (picture1[i][j] != picture2[i][j]) res++;
    }
    return res;
}
      /* Affiche une image de L lignes et C colonnes. */
void printImage(pixel picture[L][C]) {
    size_t i,j;
    if (C > 0) printf("+%*c+\n",C,' ');
    for (i=0; i<L; i++){
	printf(" ");
        for (j=0; j<C; j++)
	    printf("%c", (picture[i][j] == BLACK)?BLACK_CHAR:WHITE_CHAR);
        printf(" \n");
    }
    if (C > 0) printf("+%*c+\n",C,' ');

}
    /* Affiche une image de C lignes et L colonnes. */
void printImage2(pixel picture[C][L]) {
    size_t i,j;
    if (L > 0) printf("+%*c+\n",L,' ');
    for (i=0; i<C; i++){
	printf(" ");
        for (j=0; j<L; j++)
	    printf("%c", (picture[i][j] == BLACK)?BLACK_CHAR:WHITE_CHAR);
        printf(" \n");
    }
    if (L > 0) printf("+%*c+\n",L,' ');

}

int main(){
    // le F
    pixel tab[L][C] = {{BLACK, BLACK, BLACK, BLACK, BLACK},
		       {BLACK, WHITE, WHITE, WHITE, WHITE},
		       {BLACK, BLACK, BLACK, BLACK, WHITE},
		       {BLACK, WHITE, WHITE, WHITE, WHITE},
		       {BLACK, WHITE, WHITE, WHITE, WHITE},
		       {BLACK, WHITE, WHITE, WHITE, WHITE}};
    pixel m_central[L][C], m_horizontal[L][C], r_droite[C][L], r_gauche[C][L];
    printf("Image initiale: \n");
    printImage(tab);
    printf("Miroir Vertical: \n");
    miroirVertical(tab, m_central)   ;
    printImage(m_central);
    printf("Miroir Horizontal: \n");
    miroirHorizontal(tab, m_horizontal)   ;
    printImage(m_horizontal);
    printf("Rotation  90 a droite: \n");
    rotationDroite(tab, r_droite)   ;
    printImage2(r_droite);
    printf("Rotation  90 a gauche: \n");
    rotationGauche(tab, r_gauche)   ;
    printImage2(r_gauche); 
    printf("Comparaison entre l'image initiale et elle-mme: %lu pixel(s) diffre(nt)\n",
           compare(tab,tab));
    printf("Comparaison entre l'image initiale et son miroir central: %lu pixel(s) diffre(nt)\n",
           compare(tab,m_central));
    return 0;
}

