#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <netinet/in.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <arpa/inet.h>
#define _POSIX_C_SOURCE 2 /* Ncessaire sur certains Linux. */
#include <netdb.h>
#include <string.h>

#define MAX_SIZE 256

void error(char * msg);      // Cf. ligne /*@\ref{network::socket_TCP_client::error} du listing~\ref{network::socket_TCP_client}@*/.

void doit(int sockfd, struct sockaddr_in * serv) { // Traitement cot client.
    char linetosend[MAX_SIZE+1], reponse[MAX_SIZE];
    ssize_t n;
    struct sockaddr_in reply_addr;
    socklen_t len = sizeof(reply_addr);
    memset(&reply_addr, 0, len);

    printf("Entrez une phrase : ");
    while ( fgets(linetosend, MAX_SIZE, stdin) != NULL ) {
	n = sendto(sockfd, linetosend, strlen(linetosend), 0, 
		   (struct sockaddr *) serv, sizeof(*serv));
	if (n != strlen(linetosend)) error("[sendto]");

	n = recvfrom(sockfd, reponse, MAX_SIZE-1, 0, 
		     (struct sockaddr *)&reply_addr , &len);
	if (n < 0) error("[recv]");

	if ((len != sizeof(*serv)) || memcmp(&reply_addr, serv, len)) {
	    printf("Rponse de %s (ignore).\n", inet_ntoa(reply_addr.sin_addr));
	    continue;
	}
	reponse[MAX_SIZE] = '\0'; // Prcaution pour l'affichage.
	printf("Message reu : %s\n---\nEntrez une phrase : ", reponse);
    }
}

int main(int argc, char* argv[]) 
{
    char * servname = "localhost";
    char * port     = "6666";
    struct addrinfo hints, *res;
    int err, sockfd = -1;

    /***Traitement des arguments de la ligne de commande. ***/
    switch (argc) {
    case 3:  port     = argv[2];
    case 2:  servname = argv[1]; break;
    case 1:  break;
    default: fprintf(stderr, "Usage: %s [servname [port]]\n",argv[0]);
	     return EXIT_FAILURE;
    }
    /*** Construction de l'adresse de socket du serveur. ***/
    memset(&hints, 0, sizeof(hints));
    hints.ai_flags    = AI_CANONNAME; // On veut une rsolution de nom.
    hints.ai_family   = AF_INET;      // Adresse IPv4 uniquement.
    hints.ai_socktype = SOCK_DGRAM;   // Sockets non connecte.
    if ((err = getaddrinfo(servname, port, &hints, &res)) < 0)  {
	if (err == EAI_SYSTEM) error("[getaddrinfo]");
	fprintf(stderr, "[getaddrinfo] on %s : %s\n", servname, gai_strerror(err));
	return EXIT_FAILURE;
    }
    for(; res != NULL; res = res->ai_next) {
	/*** Cration d'une socket. ***/ 
	sockfd = socket(res->ai_family, res->ai_socktype, res->ai_protocol);
	if (sockfd < 0) continue;
	break; // Si on arrive ici, on a russi  crer la socket.
    }
    if (sockfd  < 0)   error("[socket]"); 
    doit(sockfd, (struct sockaddr_in *) res->ai_addr); // gestion des requtes
    // ... Le reste est inchang.
    
    /*** Fermeture de la socket. ***/
    close(sockfd);     
    freeaddrinfo(res); // Ne pas oublier de librer l'espace allou  res!
    return EXIT_SUCCESS;
}

void error(char * msg) {
    perror(msg);
    exit(EXIT_FAILURE);
}
