#include <stdio.h> 
#include <stdlib.h> 
#include <unistd.h>
#include <netinet/in.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <string.h>    
#include <arpa/inet.h>

#define MAX_SIZE 256
#define NUMPORT  6666    // Le port o les utilisateurs se connecteront 

void error(char * msg);      // cf. ligne /*@\ref{network::socket_TCP_client::error} du listing~\ref{network::socket_TCP_client}@*/
void traitement(int sockfd); 
int main() // Serveur UDP
{
    int sockfd; 
    struct sockaddr_in serv_addr;   // Adresse IP locale du serveur
       
    /*** Cration de l'adresse de socket locale du serveur ***/
    memset(&serv_addr, 0, sizeof(serv_addr)); // Initialisation de la structure
    serv_addr.sin_family      = AF_INET;
    serv_addr.sin_addr.s_addr = htonl(INADDR_ANY);
    serv_addr.sin_port        = htons(NUMPORT);    
    /*** Cration d'une socket ***/ 
    if ( (sockfd = socket(PF_INET,SOCK_DGRAM,0)) < 0) error("[socket]");
    /*** Attachement de la socket ***/
    if ( bind(sockfd, (struct sockaddr *) &serv_addr, sizeof(serv_addr)) < 0) 
	error("[bind]");
    while(1) { // Principale boucle pour traitement 
	traitement(sockfd);
    }
    return EXIT_SUCCESS;
}

void error(char * msg) {
    perror(msg);
    exit(EXIT_FAILURE);
}

void traitement(int sockfd) {         // Traitement cot serveur.
    char requete[MAX_SIZE];
    struct sockaddr_in cl_addr;
    memset(&cl_addr, 0, sizeof(cl_addr)); // Initialisation de la structure.
    socklen_t len = sizeof(cl_addr);  // Ne pas oublier d'initialiser len!!!

    ssize_t n1 = recvfrom(sockfd, requete, MAX_SIZE-1, 0, 
			 (struct sockaddr *)&cl_addr, &len);
    if (n1 < 0) error("[recvfrom]");
    // Rmission immdiate
    ssize_t n2 = sendto(sockfd, requete, n1, 0, (struct sockaddr *) &cl_addr, len);
    if ( n1 != n2 ) error("[sendto]");
}
