#include <stdio.h> 
#include <stdlib.h> 
#include <unistd.h>
#include <netinet/in.h>
#include <sys/socket.h>
#include <arpa/inet.h>
#define _POSIX_C_SOURCE 2 /* Ncessaire sur certains Linux. */
#include <netdb.h>
#include <string.h>

#define MAX_SIZE 256

void error(char * msg);      // cf. ligne /*@\ref{network::socket_TCP_client::error} du listing~\ref{network::socket_TCP_client}@*/
void doit(int sockfd, struct sockaddr_in * serv) {
    char requete[MAX_SIZE] = "Luc, je suis ton pre!";
    char reponse[MAX_SIZE];
    size_t request_size = strlen(requete) + 1;

    ssize_t n = sendto(sockfd, requete, request_size, 0,
		       (struct sockaddr *) serv, sizeof(*serv)); /*@\label{network::socket_UDP_client::sendto}@*/
    if ( n != request_size) error("[sendto]");
    printf("Requte envoye  %s:%d : <%s> (%ld octets)\n",
	   inet_ntoa(serv->sin_addr), ntohs(serv->sin_port), requete, (long) n);

    n = recvfrom(sockfd, reponse, MAX_SIZE-1, 0, NULL, NULL); /*@\label{network::socket_UDP_client::recvfrom}@*/
    if (n < 0) error("[recvfrom]");
    reponse[MAX_SIZE-1] = '\0'; // prcaution pour affichage
    printf("Rponse obtenue: <%s> (%ld octets)\n", reponse, (long) n);
}

int main(int argc, char* argv[]) // Client UDP 
{
    char * servname = "localhost";
    char * port     = "6666";
    struct addrinfo hints, *res;
    int err, sockfd = -1;

    switch (argc) { // Traitement des arguments de la ligne de commande 
    case 3:  port     = argv[2];
    case 2:  servname = argv[1]; break;
    case 1:  break;
    default: fprintf(stderr, "Usage: %s [servname [port]]\n",argv[0]);
	     return EXIT_FAILURE;
    }
    /*** Construction de l'adresse de socket du serveur ***/
    memset(&hints, 0, sizeof(hints));
    hints.ai_flags    = AI_CANONNAME; // On veut une rsolution de nom.
    hints.ai_family   = AF_INET;      // Adresse IPv4 uniquement.
    hints.ai_socktype = SOCK_DGRAM;   // Socket non connecte.
    if ((err = getaddrinfo(servname, port, &hints, &res)) < 0)  {
	if (err == EAI_SYSTEM) error("[getaddrinfo]");
	fprintf(stderr, "[getaddrinfo] on %s : %s\n", servname, gai_strerror(err));
	return EXIT_FAILURE;
    }
    for(; res != NULL; res = res->ai_next) {
	/*** Cration d'une socket ***/ 
	sockfd = socket(res->ai_family, res->ai_socktype, res->ai_protocol);
	if (sockfd < 0) continue;
	break; // si on arrive ici, on a russi  crer la socket
    }
    if (sockfd  < 0)   error("[socket]"); 
    doit(sockfd, (struct sockaddr_in *) res->ai_addr); // gestion des requtes

    close(sockfd);     // Fermeture de la socke
    freeaddrinfo(res); // Ne pas oublier de librer l'espace allou  res!
    return EXIT_SUCCESS;
}

void error(char * msg) {
    perror(msg);
    exit(EXIT_FAILURE);
}
