#include <stdio.h> 
#include <stdlib.h> 
#include <unistd.h>
#include <sys/socket.h>
#include <string.h>    

#define REQUETE   "Luc, je suis ton pre!"
#define REPONSE   "Nonnnnnnnnn !"

void error(char * msg);      // cf. ligne /*@\ref{network::socket_TCP_client::error} du listing~\ref{network::socket_TCP_client}@*/
int main() 
{
    int sockfd[2]; 
    char buf[1024];
    size_t answer_size  = strlen(REPONSE) + 1; 
    size_t request_size = strlen(REQUETE) + 1;

    if (socketpair(AF_UNIX, SOCK_STREAM, 0, sockfd ) < 0) error("[socketpair]");
    pid_t childpid = fork(); // creation du processus fils 
    if ( childpid < 0 ) error("[fork]");

    if (childpid) { // fork() renvoie le pid > 0 du fils au pre
	// On est donc ici dans le code a excuter par le pre
	close(sockfd[0]); // On ferme le descripteur pris en charge par le fils

	ssize_t n = recv(sockfd[1], buf, sizeof(buf)-1, 0);//Reception de la requte
	if (n < 0) error("[recv]");
	buf[sizeof(buf)-1] = '\0';
	printf("[processus pre] reception : <%s>\n",buf);
	
	n = send(sockfd[1], REPONSE, answer_size, 0); // Emission de la rponse
	if (n != answer_size) error("[send]");
	printf("[processus pre] emission  : <%s>\n",REPONSE);
	close(sockfd[1]);
    } else {
	// ici childpid = 0: on est dans le code  excuter par le fils
	close(sockfd[1]); // On ferme le descripteur pris en charge par le pre

	ssize_t n = send(sockfd[0], REQUETE, request_size, 0); // La requte
	if (n != request_size) error("[send]");
	printf("[processus fils] emission  : <%s>\n",REQUETE);
	
	n = recv(sockfd[0], buf, sizeof(buf)-1, 0); // La rponse
	if (n < 0) perror("[recv]");
	buf[sizeof(buf)-1] = '\0';
	printf("[processus fils] reception : <%s>\n",buf);
	close(sockfd[0]);
    }
    return EXIT_SUCCESS;
}

void error(char * msg) {
    perror(msg);
    exit(EXIT_FAILURE);
}
